VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5100
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7095
   LinkTopic       =   "Form1"
   ScaleHeight     =   5100
   ScaleWidth      =   7095
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtResults 
      Height          =   3615
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   3
      Top             =   1440
      Width           =   6495
   End
   Begin VB.CommandButton cmdShowStructure 
      Caption         =   "Show Structure"
      Height          =   495
      Left            =   2040
      TabIndex        =   1
      Top             =   840
      Width           =   1455
   End
   Begin VB.TextBox txtDatabase 
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Top             =   360
      Width           =   6135
   End
   Begin VB.Label Label1 
      Caption         =   "Database:"
      Height          =   255
      Index           =   1
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   855
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Add a reference to "Microsoft DAO 3.6 Object Library"
' (or whatever your version is).
Option Explicit

' Create statements to build all of the database's tables.
Public Function MakeAllCreateTableStatements(ByVal db_name As String) As String
Dim db As DAO.Database
Dim table_def As DAO.TableDef
Dim rel As DAO.Relation
Dim result As String

    ' Open the database.
    Set db = DBEngine.Workspaces(0).OpenDatabase( _
        db_name, ReadOnly:=False)

    ' Look through the tables.
    For Each table_def In db.TableDefs
        ' Make the CREATE TABLE statement for this table.
        ' Skip system tables.
        If LCase$(Left$(table_def.Name, 4)) <> "msys" Then
            result = result & MakeCreateTableStatement(table_def)
        End If
    Next table_def

    db.Close

    MakeAllCreateTableStatements = result
End Function
' Return a string representing a field's type.
Private Function MakeCreateField(ByVal fld As DAO.Field) As String
Dim result As String

    result = "  " & fld.Name

    Select Case fld.Type
        Case dbDate, dbTime, dbTimeStamp
            result = result & " DATETIME"
        Case dbMemo
            result = result & " MEMO"
        Case dbByte
            result = result & " BYTE"
        Case dbInteger
            result = result & " INT"
        Case dbLong
            result = result & " LONG"
        Case dbNumeric, dbDecimal, dbFloat
            result = result & " FLOAT"
        Case dbSingle
            result = result & " SINGLE"
        Case dbDouble
            result = result & " DOUBLE"
        Case dbGUID
            result = result & " GUID"
        Case dbBoolean
            result = result & " BOOL"
        Case dbCurrency
            result = result & " CURRENCY"
        Case dbText
            result = result & " TEXT(" & fld.Size & ")"
        Case Else
            result = result & " ????"
    End Select

    If (fld.Attributes And dbAutoIncrField) Then
        result = result & " AUTOINCREMENT"
    End If

    If fld.Required Then result = result & " NOT NULL"

    MakeCreateField = result & "," & vbCrLf
End Function
' Make a CREATE TABLE statement to make this table.
Private Function MakeCreateTableStatement(ByVal table_def As DAO.TableDef) As String
Dim result As String
Dim fld As DAO.Field

    result = "CREATE TABLE " & table_def.Name & "(" & vbCrLf

    ' Loop through the fields.
    For Each fld In table_def.Fields
        result = result & MakeCreateField(fld)
    Next fld

    ' Remove the trailing comma.
    If InStr(result, ",") > 0 Then
        result = Left$(result, InStrRev(result, ",") - 1) & vbCrLf
    End If

    ' Return the result.
    MakeCreateTableStatement = result & ");" & vbCrLf
End Function

' Make the CREATE TABLE statements for a database.
Private Sub cmdShowStructure_Click()
    txtResults.Text = MakeAllCreateTableStatements(txtDatabase.Text)
End Sub

Private Sub Form_Load()
Dim db_name As String

    db_name = App.Path
    If Right$(db_name, 1) <> "\" Then db_name = db_name & "\"
    txtDatabase.Text = db_name & "PubInfo.mdb"
End Sub


Private Sub Form_Resize()
Dim wid As Single
Dim hgt As Single

    wid = ScaleWidth - 2 * txtDatabase.Left
    If wid < 120 Then wid = 120
    txtDatabase.Width = wid

    cmdShowStructure.Left = (ScaleWidth - cmdShowStructure.Width) / 2

    hgt = ScaleHeight - txtResults.Top - 120
    If hgt < 120 Then hgt = 120
    txtResults.Width = wid
    txtResults.Height = hgt
End Sub


